
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Access_rulesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const access_rules = await db.access_rules.create(
            {
                id: data.id || undefined,
        
        subject_type: data.subject_type
        ||
        null
            ,
            
        permission: data.permission
        ||
        null
            ,
            
        expires_at: data.expires_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await access_rules.setAlbum( data.album || null, {
            transaction,
        });
        
        await access_rules.setRole( data.role || null, {
            transaction,
        });
        
        await access_rules.setUser( data.user || null, {
            transaction,
        });
        
        await access_rules.setMembership( data.membership || null, {
            transaction,
        });
        
        await access_rules.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return access_rules;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const access_rulesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                subject_type: item.subject_type
            ||
            null
            ,
            
                permission: item.permission
            ||
            null
            ,
            
                expires_at: item.expires_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const access_rules = await db.access_rules.bulkCreate(access_rulesData, { transaction });

        // For each item created, replace relation files
        

        return access_rules;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const access_rules = await db.access_rules.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.subject_type !== undefined) updatePayload.subject_type = data.subject_type;
        
        
        if (data.permission !== undefined) updatePayload.permission = data.permission;
        
        
        if (data.expires_at !== undefined) updatePayload.expires_at = data.expires_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await access_rules.update(updatePayload, {transaction});

        
        
        if (data.album !== undefined) {
            await access_rules.setAlbum(
              
              data.album,
              
              { transaction }
            );
        }
        
        if (data.role !== undefined) {
            await access_rules.setRole(
              
              data.role,
              
              { transaction }
            );
        }
        
        if (data.user !== undefined) {
            await access_rules.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.membership !== undefined) {
            await access_rules.setMembership(
              
              data.membership,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await access_rules.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return access_rules;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const access_rules = await db.access_rules.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of access_rules) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of access_rules) {
                await record.destroy({transaction});
            }
        });


        return access_rules;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const access_rules = await db.access_rules.findByPk(id, options);

        await access_rules.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await access_rules.destroy({
            transaction
        });

        return access_rules;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const access_rules = await db.access_rules.findOne(
            { where },
            { transaction },
        );

        if (!access_rules) {
            return access_rules;
        }

        const output = access_rules.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.album = await access_rules.getAlbum({
            transaction
        });
        
        
        output.role = await access_rules.getRole({
            transaction
        });
        
        
        output.user = await access_rules.getUser({
            transaction
        });
        
        
        output.membership = await access_rules.getMembership({
            transaction
        });
        
        
        output.organizations = await access_rules.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.albums,
        as: 'album',
        
        where: filter.album ? {
          [Op.or]: [
            { id: { [Op.in]: filter.album.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.album.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.roles,
        as: 'role',
        
        where: filter.role ? {
          [Op.or]: [
            { id: { [Op.in]: filter.role.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.role.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.memberships,
        as: 'membership',
        
        where: filter.membership ? {
          [Op.or]: [
            { id: { [Op.in]: filter.membership.split('|').map(term => Utils.uuid(term)) } },
            {
              status: {
                [Op.or]: filter.membership.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            
            if (filter.expires_atRange) {
                const [start, end] = filter.expires_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    expires_at: {
                    ...where.expires_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    expires_at: {
                    ...where.expires_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.subject_type) {
                where = {
                    ...where,
                subject_type: filter.subject_type,
            };
            }
            
            if (filter.permission) {
                where = {
                    ...where,
                permission: filter.permission,
            };
            }
            


      

      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.access_rules.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'access_rules',
                        'permission',
                        query,
                    ),
                ],
            };
        }

        const records = await db.access_rules.findAll({
            attributes: [ 'id', 'permission' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['permission', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.permission,
        }));
    }

    
};

